<?php

namespace Drp\SimpleCms\Policies;

use Drp\SimpleCms\Contracts\CmsUser;
use Drp\SimpleCms\Contracts\Publishable;
use Illuminate\Auth\Access\HandlesAuthorization;

class PublishablePolicy
{
    use HandlesAuthorization;

    // phpcs:disable Generic.CodeAnalysis.UnusedFunctionParameter.Found
    public function publish(CmsUser $user, ?Publishable $content = null): bool
    {
        return $user->hasPublishAccess();
        // phpcs:enableGeneric.CodeAnalysis.UnusedFunctionParameter.Found
    }

    // phpcs:disable Generic.CodeAnalysis.UnusedFunctionParameter.Found
    public function create(CmsUser $user, ?Publishable $content = null): bool
    {
        return $user->hasCreateAccess();
        // phpcs:enableGeneric.CodeAnalysis.UnusedFunctionParameter.Found
    }

    public function review(CmsUser $user, ?Publishable $content = null): bool
    {
        return $content->isInReview() ? $user->hasPublishAccess() : true;
    }

    // phpcs:disable Generic.CodeAnalysis.UnusedFunctionParameter.Found
    public function delete(CmsUser $user, ?Publishable $content = null): bool
    {
        return $user->hasPublishAccess();
        // phpcs:enable Generic.CodeAnalysis.UnusedFunctionParameter.Found
    }
}
